unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MMSystem, ExtCtrls;

type
  TForm1 = class(TForm)
    Button_Alarm: TButton;
    Edit1: TEdit;
    Button_Start: TButton;
    Label1: TLabel;
    Timer1: TTimer;
    Button_Stop: TButton;
    procedure Button_AlarmClick(Sender: TObject);
    procedure Button_StartClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button_StopClick(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  mytime,alert_count:longint;

implementation

{$R *.dfm}


procedure TForm1.Button_AlarmClick(Sender: TObject);
begin
  ChDir(ExtractFilePath(Application.ExeName));
  sndPlaySound('alert.wav', SND_NODEFAULT Or SND_ASYNC);
end;

procedure TForm1.Button_StartClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
  Timer1.Interval:=60000; // 1 minute
  mytime:=StrToInt(Edit1.Text);
  alert_count:=0;
  Timer1.Enabled:=true;

  Caption:='Go! Go! Go!';
  Application.Title:=Caption;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  // no check here, we want negative times to see how much we are over
  dec(mytime);

  // 0 - 5 mins, every minute
  // 6 - 20 mins, every 2 mins
  // 21 - 60 mins, every 5 min
  // after 1 hr - assume the alert has been forgotten
  if mytime <= 0 then
  begin
    inc(alert_count);
    case alert_count of
      0..5: Button_AlarmClick(Sender);
      6..20: if alert_count mod 2 = 0 then Button_AlarmClick(Sender);
      21..60: if alert_count mod 5 = 0 then Button_AlarmClick(Sender);
    end;
  end;

  if mytime >= 0 then Caption:=IntToStr(mytime) + ' left'
                 else Caption:='+' + IntToStr(abs(mytime)) + ' over';

  Application.Title:=Caption;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
begin
  Timer1.Enabled:=false;

  Caption:='Stop.';
  Application.Title:=Caption;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if ord(Key) = VK_RETURN then Button_StartClick(Sender);
end;

end.

